## gujin-2.8.7.tar.gz

=== Makefile ===
# Makefile

# Gujin is a bootloader, it loads a Linux kernel from cold boot or DOS.
# Copyright (C) 1999-2013 Etienne Lorrain, fingerprint (2D3AF3EA):
#   2471 DF64 9DEE 41D4 C8DB 9667 E448 FF8C 2D3A F3EA
# E-Mail: etienne@gujin.org
# This work is registered with the UK Copyright Service: Registration No:299755
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License,
# version 2, as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

###################################
# This is not really a Makefile configuration variable, just the
# default parameter for "./gujin", it is easier to put it here.
# Normally, you should not give here the "ide[0-9]=0x..." fields
# that you may give usually to other bootloaders, it is automatically
# added at startup by Gujin.
# --cmdline="" max size is 63 bytes.
# Just start without definning it, and come back here if needed or
# directly type the complete command line (./gujin --xxx).
#
#INSTBOOT_DEFAULT_PARAMETER=--cmdline="hdg=ide-scsi" --default_ide_password=abc
#INSTBOOT_DEFAULT_PARAMETER=--cmdline="ide0=0xb400,0xb802 ide1=0x170,0x376 root=/dev/hdc2"
INSTBOOT_DEFAULT_PARAMETER=-w=s

###################################
#### DO NOT FORGET to do 'make clean', if you modify any of the
####  following configuration values !
####
#### GCC and BINUTILS need to be built before everything - if you want
#### or need to use other version than those installed on your computer,
#### type 'make toolchain' first having all tar.gz in the parent directory.
#### make proper will not clean the toolchain.

###################################
# This is the general setup, you describe here in this "make
# variable" what you want to do by ORing the different constants:
#
#  - The kind of assembly primitives you want to acces memory over 64Kb,
#  mostly video memory, select by ORing with one (and only one) of those:
#  ASSEMBLY_NONE, ASSEMBLY_CISC, ASSEMBLY_RISC, ASSEMBLY_DSES
#  This is mostly an optimisation matter, it does not fundamentaly
#  changes the features of the bootloader.
#  Here is the description of each of them:
#    ASSEMBLY_NONE :
#       use C equivalent as much as possible, hopes that the
#       optimiser is perfect... The inline functions gpeek*()
#       and gpoke*() using segment %gs are used everywhere.
#    ASSEMBLY_CISC :
#       flavour complex addressing mode to reduce the number
#       of instructions, use segment %gs.
#    ASSEMBLY_RISC :
#       flavour simple addressing mode even if there is more
#       instructions than the strict minimum, use segment %gs.
#    ASSEMBLY_DSES :
#       This is the only choice where segments "%gs" and "%fs"
#       are not used - and segment doors for all segments are
#       open very early in the boot process - not only when a
#       VESA2 video mode is selected. It requests a little bit
#       more instructions (to manage offsets) but can be quicker.
#  NOTE: the first three options do not need to open the
#    segment doors for VESA1 modes (modes with a window in
#    the first 1024 Kb) - do not forget that the 80x86 is
#    in real mode here and cannot access more than 1 Mbyte
#    without openning the segment doors!
#    If a DOS bootloader is produced, you cannot open segment
#    doors when the processor is in virtual mode, i.e. after
#    loading Winblows or in DOSEMU.
#
#  - The position of the pool of memory managed by malloc functions,
#  it can be either in between the last data of the software and
#  the bottom of the stack, of after the stack. In the latter
#  case, the pool size can be bigger (up to 640 Kbytes), but the
#  software needs then to have segment doors open, and as said
#  before will not run in virtual mode. The default is to keep the
#  malloc pool below the stack (approx 45 Kbytes can be malloced),
#  else you OR the value with BIG_MALLOC.
#
#  - If you want to support all the language possible, you OR
#  that variable with MULTILINGUAL, else only English is supported,
#  having only a single language is better for DEBUG because of the
#  reduced available size to store strings.
#
#  -If you want more than 2 or 3 languages, the "const" memory area
#  becomes too small (mostly for non tiny version, which have a lot more
#  messages), so you can move all those strings into a new segment
#  by ORing the value with XSTRING_SEGMENT.
#
#  - If you want to support more than 256 char fonts, you OR
#  that variable with UNICODE_FONT, should not be enabled with DEBUG.
#
#  - By default the total size (code+const+variable) is 64 Kb
#  because everything is loaded in only one segment, i.e.
#  registers cs = ds = es. It is easy to change cs segment,
#  that is the segment of the code, to point to some other
#  place - and this adds just few bytes of code, so you can
#  OR the value with CODE_SEGMENT safely.
#  For the DOS bootloader "gujin.com", it does not change its
#  maximal size of 64 Kb because it is loaded by DOS, but the
#  bootloader "gujin.exe" and the BIOS bootloader (floppy or
#  HD sector 0) is then limited to 64Kb of code _plus_ 64Kb
#  of data (including stack and malloc pool) with this define.
#
#  - If there is large arrays accessed only in few cases (i.e. only
#  with farptr), like character fonts, they can be placed in an extra
#  data segment located in between code and real data, just before
#  the real data. Its maximum size is one ix86 segment, i.e. 64Kb.
#  This option is only available if CODE_SEGMENT is defined, and
#  is named XDATA_SEGMENT.
#  I am considering this segment read-only for now, i.e. for const
#  in the "C" meaning. Maybe one day I will try to compress this
#  segment (and decompress it by the loader) so I am not including
#  the gunzip constants in it.
#
#  - To reduce the size of the code segment, one way is to move some
#  functions in an extra code segment. If you OR the previous define
#  with XCODE_SEGMENT, a new i8086 segment is used to store the
#  gzlib functions (gzlib.o), functions which use them (fs.c),
#  and the disk access (disk.c).
#  This does _not_ need to have segment doors opened, but you need
#  to have CODE_SEGMENT OR'ed (it is not interresting without).
#
#  - To be able to store some information (default video mode, VGA mode
#  valid if your video board is not VESA compliant...) in between boots,
#  a special sector part can be updated on the floppy disk (the first
#  sector of the file called boot-xxx.sys). This shall be disabled when
#  you do not want to write to _any_ disk (after making unsafe modification
#  to the source), then the software do not contains the code to write
#  to anything near a FD/HD/IDE. The part written (structure gujin_param)
#  is protected by checksum, so do not modify this with an hexadecimal
#  editor!
#
#  - To save few bytes of code, you can OR with BIOS_ONLY. Then, you
#  can no more use "instboot" to generate an executable "gujin.exe" or
#  "gujin.com".
#
#  - If a DOS bootloader is produced, HIMEM.SYS (and so EMM386.EXE) presence
#  is checked and this memory interface is then used. If such a memory driver
#  does not exist or a BIOS bootfloppy is done, there is two solutions to
#  manage memory over 1 Mb: use BIOS service INT15/ah=0x87 or open segment
#  doors and use long pointers. The first BIOS one is selected when
#  SETUP is OR'ed with USE_INT1587 - the bootloader is then completely
#  compatible (up to vmlinuz_start() function) but maybe a little bit
#  slower and nobody knows if this documented interrupt is working on every
#  PCs. Else (USE_INT1587 not OR'ed), the segment doors are open when
#  the vmlinux/kernel file is loaded.
#
#  - If you really want Gujin to be quite (try to not display anything),
#  and so save constant (string) space, like the "verbose" flags at compile
#  time, you can OR with QUITE
#
#  - If you do not want to retry a read operation in Gujin 1st stage
#  bootloader (while loading Gujin 2) but instead call INT 0x19 BIOS
#  service which say "try next bootable device" - for instance when
#  the CDROM is not bootable, you do not want to enter an infinite
#  loop but try the hard disk - then do an OR with BOOT_NEVER_RETRY
#  It is now the default because I have never seen a floppy not
#  correctly reading a sector at the first time (officially you have
#  to retry three times) - unless there is a real error and then the
#  same erroneous data is read and re-read in an infinite loop.
#  Same (and worse) for CDROM because the data (with checksum error)
#  is cached anyways in the drive...
#  Gujin-1.6: Do not define BOOT_NEVER_RETRY here but use instboot
#  "--read_retry" command line switch.
#
#
# Simply select your choice, and if the software is too big for what you
# selected, the linker will complain because it cannot fit everything in
# the "ram" memory area:

# Intermediate variable:
#SETUP_STD_APPLI=CODE_SEGMENT|XCODE_SEGMENT|XDATA_SEGMENT|ASSEMBLY_DSES
#SETUP_STD_APPLI=CODE_SEGMENT|XCODE_SEGMENT|XDATA_SEGMENT|ASSEMBLY_RISC
#SETUP_STD_APPLI=CODE_SEGMENT|XCODE_SEGMENT|XDATA_SEGMENT|ASSEMBLY_NONE
SETUP_STD_APPLI=CODE_SEGMENT|XCODE_SEGMENT|XDATA_SEGMENT|ASSEMBLY_CISC
#SETUP_STD_APPLI=CODE_SEGMENT|XCODE_SEGMENT|ASSEMBLY_CISC

ifndef SETUP	# default
SETUP=$(SETUP_STD_APPLI)|UPDATE_BOOTPARAM|USE_INT1587|MULTILINGUAL|XSTRING_SEGMENT|UNICODE_FONT
endif

###################################
# Define here the user interfaces supported by the bootloader:
# The list of option is: (bigger => slower to load from floppy)
#
# VGA_SUPPORT		support of the VGA modes
# VGA_EXTENDED		modes > 0x13 can be probed/used
# VGA_MEMORY		direct memory access, now only for text modes
# VGA_USEINT1013	use _VGA_writestring, reduces code size
# VGA_INT1013_BG	use background color for 256 color modes, do not work
#
# VESA_WINDOW		VESA 1 compatible (slows VESA2 execution)
# VESA_STRANGE_WINDOW	window without 2^x bytes granularity, slow
# VESA_WINFUNCTION	optimise by using function instead of interrupt
# VESA_HARDWINDOW	analyse first code to change window(s)
# VESA_2WINDOWS		use separate read & write window if present
#
# VESA_LINEAR		VESA 2 only (cannot handle VESA1 only boards
#				with modes having more than 64K/screen)
# VESA_EDID		interrogate screen with EDID
# VESA_PMINFO		Get the I/O ports used by the graphic card
# VESA_RECALC		Correct number of visible lines if EGA compatible
#
# VESA_4BPP_EGA 	4 Bits Per Pixel	(big code size)
# VESA_4BPP_TEXT	text modes, 16 colors
# VESA_1BPP		1 Bit Per Pixel (monochrome graphic)
# VESA_8BPP		8 Bits Per Pixel
# VESA_4BPP		4 Bits Per Pixel with only one plane (ununsual)
# VESA_16BPP		15 or 16 Bits Per Pixel
# VESA_24BPP		24 Bits Per Pixel
# VESA_32BPP		32 Bits Per Pixel
#
# SERIAL_VT100		only VT100 (restriction not implemented)
# SERIAL_VT420		VT420 mode (36 and 48 lines/screen)
#
# BIOS_MOUSE_SUPPORT	for BIOS mouses (mostly PS2): INT0x15/ah=0xC2.
# SERIAL_MOUSE_SUPPORT  standard serial mouse driver on one of the first
#			4 COM ports declared to BIOS
# JOYSTICK_SUPPORT	self explanatory, not tested on much hardware.
#
# I know there is too many parameter to configure this subsystem,
# so there is few pre-build choice at end.
#

# Intermediate variables:
# only fast modes:
VESAMODE_FEW = VESA_16BPP|VESA_32BPP

# without palette management:

# forget 1BPP : VESAMODE_STD = $(VESAMODE_FEW)|VESA_1BPP|VESA_24BPP
# forget 1BPP : 1 BPP & 1 plane does not work on my Vodoo3 (640x200) because CGA pixel memory
# forget 1BPP : organisation, do not know about 1 BPP & 4 planes (640x350 & 640x480).

=== debian/changelog ===
gujin (2.8.7) unstable; urgency=low

  * Release based on Gujin-2.8.7

  * Release based on Gujin-2.8.6

  * Release based on Gujin-2.8.5

  * Release based on Gujin-2.8.4

  * Release based on Gujin-2.8.3

  * Release based on Gujin-2.8.2

  * Release based on Gujin-2.8.1

  * Release based on Gujin-2.8

  * Initial Release based on Gujin-2.7

 -- Etienne Lorrain <etienne.lorrain@gujin.org>  Wed, 9 Jan 2013 19:50:43 +0100

=== debian/control ===
Source: gujin
Section: admin
Priority: extra
Maintainer: Etienne Lorrain <etienne.lorrain@gujin.org>
Build-Depends: debhelper (>= 7)
Standards-Version: 3.9.3
Homepage: http://gujin.org

Package: gujin
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: graphic boot-loader with mouse for IA32/amd64
 This is a PC boot-loader which, like Lilo and unlike Grub, run completely
 in IA32 real mode (easier to chain-boot other O.S. which expect real-mode
 entry point, or chain-load El-Torito CD/DVDROM, reply natively to unknown
 BIOS interrupts), but like Grub and unlike Lilo, understand file-systems
 and can load kernel/initrd files by their file name, instead of needing to
 be configured with the position/size of the file to load.
 Moreover, unlike any other boot-loader, Gujin is fully graphic (selection
 of the kernel to boot with the mouse), and do not need any configuration
 (but maybe per-distribution /boot/gujin.cmd) because it auto-detects
 BIOS disk order and kernels in the file-systems it understands
 (FAT12/16/32, EXT2/3/4, ISO9660). Standalone/tiny versions are also
 available, they do not display a menu but load the newest kernel found.
 Installing this package will not only install the Gujin installer named
 "gujin", but also install Gujin in the file /boot/gujin.ebios, modifying
 the MBR of the disk.
 If for whatever reason Gujin do not work for you, you can uninstall it
 from the boot-loader itself, and it will restore the previously installed
 boot-loader.
 The installer can be used to initialize and make boot-able floppy disks,
 USB sticks/SD cards, CD/DVD-ROMs, and to query which boot-loader is
 currently installed.
 Removing this package will also replace the MBR with the one saved at
 installation time, so your disk should remain boot-able.
 Note that because Gujin runs natively in real mode, two implementations
 (with and without menu) can be run from DOS, see the man page.
 This package do not need any external libraries, so can be compiled
 indifferently on IA32 hosts or on amd64 hosts.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1





configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.

	touch configure-stamp


build build-indep build-arch: build-stamp

build-stamp: configure-stamp  
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE)
	#docbook-to-man debian/gujin.sgml > gujin.1

	touch $@

clean: 
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp files

	# Add here commands to clean up after the build process.
	$(MAKE) clean

	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_prep -k 
	dh_installdirs

	# Add here commands to install the package into debian/gujin.
	$(MAKE) DESTDIR=$(CURDIR)/debian/gujin install


# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installexamples
#	dh_install
#	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_python
#	dh_installinit
#	dh_installcron
#	dh_installinfo
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_perl
#	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build build-indep build-arch clean binary-indep binary-arch binary install configure
